unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,opengl, StdCtrls, ModPl,mmsystem;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  tm:uint;
  dc:hdc;
  hrc:hglrc;
  public
  procedure SetDCPixelFormat;

 protected
 procedure WMPaint(var Msg: TWMPaint); message WM_PAINT;
 end;


var
  Form1: TForm1;
  s:array[1..3] of pchar;
  mc:array[1..3]of GLFloat;{material color}
  lp:array[1..4]of GLFLoat;{light pos}
  i,k,g,h,b,b1,j,t,angle,a,br,tx,cs:glfloat;{for moving}
  fl,flag,lpos,cn,count,timer:byte;{flags and counts}
  a1,i1,count1,p:integer;
  pic:array[0..225,0..110]of tcolor;
  img,img1:array[1..150,0..150,0..2]of glubyte;
  music:pointer;{music handle}
implementation

{$R *.DFM}
procedure Ontimer(uTimerID, uMessage: UINT;dwUser, dw1, dw2: DWORD) stdcall;
begin
if timer=1 then begin
angle:=angle+0.4;
 if fl=0 then i:=i+0.01;
 if fl=1 then k:=k-0.02;
 if fl=2 then begin b:=b-0.1;b1:=b1+0.02;end;
 if (flag=0) and (fl=3) then j:=j+0.05;
 if flag=1 then begin j:=j+0.05;
 if t<1 then t:=t+0.05;end;
 if flag=2 then t:=t-0.05;
end;
if timer=3 then begin
if flag=0 then
if a<355 then a:=a+1 else flag:=1;
if flag=1 then count:=count+1;
if flag=2 then begin cn:=cn+1;end;
if flag=3 then begin
if tx<=20.5 then tx:=tx+0.1;
 if br<=150 then br:=br+5;
if p<=120 then p:=p+5;
j:=j+0.05;
end;
end;
 InvalidateRect(form1.handle, nil, False);
end;

procedure drawpoly;
begin
glbegin(gl_polygon);
 glvertex2f(0,1);
 glvertex2f(-0.2,0);
 glvertex2f(0.2,0);
glend;
glbegin(gl_polygon);
 glvertex2f(0,-1);
 glvertex2f(-0.2,0);
 glvertex2f(0.2,0);
glend;
glbegin(gl_polygon);
 glvertex2f(1,0);
 glvertex2f(0,-0.2);
 glvertex2f(0,0.2);
glend;
glbegin(gl_polygon);
 glvertex2f(-1,0);
 glvertex2f(0,-0.2);
 glvertex2f(0,0.2);
glend;
end;
procedure polys;
begin
glpushmatrix;
 gltranslatef(0,0,-1);
 glrotatef(45,0,0,1);
 mc[1]:=0;mc[2]:=0;mc[3]:=0.4;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
drawpoly;
glpopmatrix;
glpushmatrix;
 gltranslatef(0,0,-2);
 glrotatef(22.5,0,0,1);
 mc[1]:=0;mc[2]:=0;mc[3]:=0.5;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
drawpoly;
glpopmatrix;
glpushmatrix;
 gltranslatef(0,0,-3);
 glrotatef(-20,0,0,1);
 mc[1]:=0;mc[2]:=0;mc[3]:=0.6;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
drawpoly;
glpopmatrix;
end;
procedure drawpolys;
begin
glpushmatrix;
 gltranslatef(3,0,-6);
polys;glpopmatrix;
glpushmatrix;
 gltranslatef(-3,0,-6);
polys;glpopmatrix;
glpushmatrix;
 gltranslatef(0,-4,-9);
polys;glpopmatrix;
glpushmatrix;
 gltranslatef(0,4,-9);
polys;glpopmatrix;
glpushmatrix;
 gltranslatef(3,4,-5);
polys;glpopmatrix;
glpushmatrix;
 gltranslatef(3,-4,-5);
polys;glpopmatrix;
glpushmatrix;
 gltranslatef(-3,-4,-5);
polys;glpopmatrix;
glpushmatrix;
 gltranslatef(-3,4,-5);
polys;glpopmatrix;
glpushmatrix;
 gltranslatef(-6,0,-6);
polys;glpopmatrix;
glpushmatrix;
 gltranslatef(6,0,-6);
polys;glpopmatrix;
end;
procedure smooth;
var i,k:integer;
r1,g1,b1:integer;
begin
 for k:=0 to 150 do
 for i:=0 to 150 do begin
 r1:=img[i-1][k][0]+img[i+1][k][0]+img[i][k-1][0]+img[i][k+1][0]-2;
 g1:=img[i-1][k][1]+img[i+1][k][1]+img[i][k-1][1]+img[i][k+1][1]-2;
 b1:=img[i-1][k][2]+img[i+1][k][2]+img[i][k-1][2]+img[i][k+1][2]-2;
 img[i][k][0]:=round(r1/4);
 img[i][k][1]:=round(g1/4);
 img[i][k][2]:=round(b1/4);
 end;
end;
procedure glrectangle(x,y:glfloat);
begin
glbegin(gl_lines);
 glvertex2f(-x,y);
 glvertex2f(x,y);
 glvertex2f(x,y);
 glvertex2f(x,-y);glvertex2f(x,-y);
 glvertex2f(-x,-y);
 glvertex2f(-x,-y);
 glvertex2f(-x,y);
glend;
end;

procedure drawquads;
begin
 glBegin (GL_QUADS);
    glVertex3f (-1.5, -1.5, 0.0);
    glVertex3f (0.0, -1.5, 0.0);
    glVertex3f (0.0, 0.0, 0.0);
    glVertex3f (-1.5, 0.0, 0.0);

    glVertex3f (0.0, -1.5,0.0);
    glVertex3f (1.5, -1.5, 0.0);
    glVertex3f (1.5, 0.0, 0.0);
    glVertex3f (0.0, 0.0, 0.0);

    glVertex3f (0.0, 0.0, 0.0);
    glVertex3f (1.5, 0.0, 0.0);
    glVertex3f (1.5, 1.5, 0.0);
    glVertex3f (0.0, 1.5, 0.0);

    glVertex3f (0.0, 0.0, 0.0);
    glVertex3f (0.0, 1.5, 0.0);
    glVertex3f (-1.5, 1.5, 0.0);
    glVertex3f (-1.5, 0.0, 0.0);
    glEnd;
end;
procedure OutText3d(txt : PChar);
begin
glpushattrib(gl_all_attrib_bits);
 glListBase(2000);
 glCallLists(Length (txt), GL_UNSIGNED_BYTE, txt);
glpopattrib;
end;

procedure outtext(x,y:glfloat;ch:pchar);
begin
gllistbase(1000);
glrasterpos3f(x,y,0);
glpushattrib(gl_all_attrib_bits);
 glcalllists(1,GL_UNSIGNED_BYTE,ch);
glpopattrib;
end;
procedure showcmp(j,x:glfloat);
begin
 mc[1]:=j;mc[2]:=j;mc[3]:=j+0.1;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
 outtext(-0.8,k+x,'');outtext(-0.6,k-x,'');
 outtext(-0.4,k+x,'');outtext(-0.2,k-x,'');
 outtext(0.0,k+x,'');outtext(0.2,k-x,'');
 outtext(0.4,k+x,'');outtext(0.6,k-x,'');
 outtext(0.8,k+x,'');
end;
procedure tform1.setDcPixelFormat;
var
pfd:TPixelFormatDescriptor;
npf:integer;
begin
fillchar(pfd,sizeof(pfd),0);
with pfd do begin
nSize:=sizeof(pfd);
dwFlags:=PFD_DRAW_TO_WINDOW or
        PFD_SUPPORT_OPENGL or
        PFD_DOUBLEBUFFER;
end;
npf:=choosepixelformat(dc,@pfd);
setpixelformat(dc,npf,@pfd);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 dc:=getDC(handle);
 setDCpixelFormat;
 hrc:=wglcreatecontext(dc);
 wglMakeCurrent(dc,hrc);
 glclearcolor(0,0,0,0);
 glmatrixmode(gl_projection);
 glFrustum(-1,1,-1,1,0,20);
 glmatrixmode(gl_modelview);
 glloadidentity;
 wglusefontbitmaps(canvas.handle,0,255,1000);
 wglusefontoutlines(canvas.handle,0,255,2000,0,0.15, WGL_FONT_POLYGONS,nil);
 glenable(gl_lighting);
 glenable(gl_light0);
 glenable(gl_normalize);
 glenable(gl_line_smooth);
  randomize;
s[1]:='';s[2]:='';s[3]:='';
i:=0.05;k:=0.85;fl:=0;b:=1;j:=0.01;
t:=0;angle:=0.5;
tm:=timesetevent(50,0,@Ontimer,0,TIME_PERIODIC);
timer:=2;
showcursor(false);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var t:tdevmode absolute 0;
begin
 timekillevent(tm);
 showcursor(true);
 mp_stopit(music);
 mp_setpos(music,0);
 mp_destroyit(music);
wglMakeCurrent(0, 0);
  wglDeleteContext(hrc);
  ReleaseDC(Handle, DC);
  DeleteDC(DC);
changedisplaysettings(t,cds_fullscreen);
application.terminate;
end;

procedure ontimer1;
begin
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 if i>0.8 then fl:=1;
 if k<0.1 then begin fl:=2;end;
 gldisable(gl_light0);
 lpos:=lpos+1;
{lpos:=random(8);}
if lpos=9 then lpos:=1;
case lpos of
1:begin g:=-1;h:=1;end;
2:begin g:=0;h:=1;end;
3:begin g:=1;h:=1;end;
4:begin g:=1;h:=0;end;
5:begin g:=1;h:=-1;end;
6:begin g:=0;h:=-1;end;
7:begin g:=1;h:=-1;end;
8:begin g:=-1;h:=-1;end;
else end;
 lp[1]:=g/3;lp[2]:=h/3;lp[3]:=1;lp[4]:=2+t*100;
 gllightfv(gl_light0,GL_POSITION,@lp);
 glenable(gl_light0);
{}
 glrotatef(angle-20,0,0,1);
 mc[1]:=0+t;mc[2]:=0+t;mc[3]:=0.4+t;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
 drawquads;
glpushmatrix;

{ }
glloadidentity;
 if fl=2 then begin
  mc[1]:=b;mc[2]:=b;mc[3]:=b;
  if b<0.2 then begin fl:=3;b1:=0;end;
  end;
 if (flag=0) and (fl=3) then begin
  showcmp(j,0);
   if j>0.6 then begin flag:=1;j:=0;end;
 end;
if flag=1 then begin
 showcmp(1,j);
 angle:=t*10;
 if j>1 then flag:=2;
end;
if flag=2 then begin
 if t<-0.2 then begin flag:=3;
 mc[1]:=0;mc[2]:=0;mc[3]:=0.45;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
 drawquads;
 end;
end;
if flag=3 then begin
 timer:=3;
 i:=0;k:=0;
 glmatrixmode(gl_projection);
 glFrustum(-1,1,-1,1,2,20);
 glmatrixmode(gl_modelview);
 glloadidentity;
 glclearcolor(1,1,1,0);
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glclearcolor(0,0,0,0);
 glenable(gl_depth_test);
 flag:=0;j:=-2;g:=0;h:=0;t:=0;angle:=0;
end;
if fl<=2 then begin mc[1]:=1;mc[2]:=1;mc[3]:=1;end;
glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
if fl<3 then begin
   outtext(-i-b1,k,s[1]);outtext(0,k,s[2]);outtext(i+b1,k,s[3]);
end;
glpopmatrix;
glflush;
swapbuffers(form1.dc);
end;
procedure ontimer2;
var td:tdevmode;
begin
form1.left:=0;form1.top:=0;
 music:=mp_createit(' ');
 mp_setw(music,form1.panel1.handle);
 mp_loadit(music,'mk1.it');
with td do begin
 dmsize:=sizeof(td);
 dmbitsperpel:=16;
 dmpelswidth:=640;
 dmpelsheight:=480;
 dmfields:=dm_bitsperpel or dm_pelswidth or dm_pelsheight;
 changedisplaysettings(td,cds_fullscreen);
end;
mp_playit(music);
end;

procedure ontimer3;
var col:glfloat;
y,e:integer;
begin
gllinewidth(1);
if (flag=1) and (count>=10) then  begin
 flag:=2;
 for e:=1 to 110 do
 for y:=1 to 225 do
 pic[y,e]:=getpixel(form1.dc,y+209,e+180);
 count:=0;
end;
glPushMatrix;
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glclearcolor(0,0,0,0);
 gldisable(gl_light0);
 lpos:=lpos+1;
 if lpos=9 then lpos:=1;
 case lpos of
 3:begin g:=1;h:=1;end;
 5:begin g:=1;h:=-1;end;
 8:begin g:=-1;h:=-1;end;
 else end;
 mc[1]:=0;mc[2]:=0;mc[3]:=1;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
glrotatef(a*10,0,0,1);
gltranslatef(0,0,-a/150-4.5);
gldisable(gl_light0);
lp[1]:=g/3;lp[2]:=h/3;lp[3]:=1;lp[4]:=10+t*100;
gllightfv(gl_light0,GL_POSITION,@lp);
glenable(gl_light0);
gltranslatef(0,0,cn/10);
drawpoly;

if flag<3 then begin
 polys;
 drawpolys;
 glloadidentity;
 glTranslatef(-a/350, -0.2, -2-a/100+cn/10);
 glRotatef(10+a, 0,1,0);
end;
MC[1]:=1; MC[2]:=1; MC[3]:=0;
glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, @MC);
gldisable(gl_light0);
lp[1]:=g/3;lp[2]:=h/3;lp[3]:=1;lp[4]:=2+t*100;
gllightfv(gl_light0,GL_POSITION,@lp);
glenable(gl_light0);
OutText3d('');
glloadidentity;
glscalef(0.445,0.445,1);
glTranslatef(-2.48, -1.25,-1-a/68+cn/10);
outText3d('');
MC[1]:=1; MC[2]:=0; MC[3]:=0;
glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, @MC);
glbegin(gl_polygon);
glvertex2f(-0.9,3.0);
glvertex2f(-0.4,3.0);
glvertex2f(-0.9,2.4);
glend;
glbegin(gl_polygon);
glvertex2f(-4.95,-0.3);
glvertex2f(-4.05+1,-0.3);
glvertex2f(-4.95,-2.6);
glend;
MC[1]:=1; MC[2]:=1; MC[3]:=1;
glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, @MC);
glbegin(gl_lines);
glvertex2f(-0.1,0.60);
glvertex2f(-4.95,0.60);
glend;
glpushmatrix;
gltranslatef(-2.5,1,-0.9);
if (cn>50) and (flag<>3) then begin flag:=3;
 lpos:=2; p:=0;br:=0;
 gldisable(gl_light1);
 lp[1]:=0;lp[2]:=0;lp[3]:=1;lp[4]:=0;
 gllightfv(gl_light1,GL_POSITION,@lp);
 glenable(gl_light1);
end;
{///}
if flag=3 then begin
 glpushmatrix;
 angle:=angle+10;
 glrotatef(angle,0,0,1);
 gllinewidth(2);
 count1:=count1+1;
 if count1=5 then count1:=0;
 if count1=0 then begin
 mc[1]:=1;mc[2]:=1;mc[3]:=1;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
 col:=random(40)/100;
glpushmatrix;
gltranslatef(0,0,-1);
if p>115 then glrectangle(0.5-col,0.5-col);
 glreadpixels(245,135,150,150,gl_rgb,gl_unsigned_byte,@img1);
  glpopmatrix;
 {  }
 for y:=0 to 150 do
 for e:=0 to 150 do
  if img1[e][y][0]>150 then begin
   img[e][y][0]:=255;img[e][y][1]:=255;
   img[e][y][2]:=255;end;
  end;
 smooth;smooth;smooth;smooth;
 glrotatef(-angle,0,0,1);
j:=j+0.05;
if j>2.5 then j:=-2;
gltranslatef(0,0,-0.1);
 glrasterpos2f(j-1,1);
 gldrawpixels(150,150,gl_rgb,gl_unsigned_byte,@img);
glrasterpos2f(-j,-1.8);
 gldrawpixels(150,150,gl_rgb,gl_unsigned_byte,@img);
 glrasterpos2f(-0.8,0);
mc[1]:=0;mc[2]:=0;mc[3]:=0;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
glrectf(-3,-0.05,3,-2);
glenable(gl_color_material);
if br<=150 then br:=br+5;
if p<=120 then p:=p+5;

for e:=1 to 225 do begin
if (p>119) and (cs<600) then cs:=cs+0.1;

for y:=1 to 110 do
begin
 if (getbvalue(pic[e,110-y])<50) then
 glcolor3ub(getrvalue(pic[e,110-y]),getgvalue(pic[e,110-y]),getbvalue(pic[e,110-y]))
  else glcolor3ub(0,0,0);
 glbegin(gl_points);
 glvertex2f(e/br-0.7,y/p-cos(cs)/60-0.1);
 glend;
end; end;
gldisable(gl_color_material);
glpushmatrix;
mc[1]:=0;mc[2]:=0.9;mc[3]:=0;
 glmaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,@mc);
 glscalef(0.2,0.2,1);;
if tx<=20.5 then tx:=tx+0.1;
 gltranslatef(10-tx,-9.5,0.1);
 outtext3d('PROGRAMMING & MUSIC BY RIZVANOV RUSLAN');
glpopmatrix;
 glpopmatrix;
end;
 {///}
glpopmatrix;
glPopMatrix;
glflush;
swapbuffers(form1.dc);
end;

procedure Tform1.WMPaint(var Msg: TWMPaint);
begin
if timer=1 then begin ontimer1;end;
if timer=2 then begin ontimer2;timer:=1;end;
if timer=3 then begin ontimer3;end;
end;
end.
